;ͻ
;                          Peak BETA 2۲                              
;                           Peak Header File                                
;                                 Peak.h                                    
;                           February 12,1999                                
;͹
;                            by Richard Lewis                               
;                       RichardLewis@CedarCity.net                          
;                                                                           
;                         Misc. help provided by                            
;                               Greg Sharp                                  
;                            BSharp81@aol.com                               
;͹
; Various other people too numerous to name have helped me with other       
;  projects that led up to this one.                                        
;ͼ
;Ŀ
; Shell Version data in BCD (Binary Coded Decimal) format                   
;
SUMMIT_B4       =$04
RIGEL_VER       =$10
USGARD_15L_VER  =$24
USGARD_15F_VER  =$25
ZSHELL4_VER     =$40
PHATOS_VER      =$50

;Ŀ
; Graph Screen Macros (Shouldn't affect ASM at all)                         
;
#DEFINE GUSE_GRAPH		res 0,(IY+$03)
#DEFINE GREDRAW_GRAPH		set 0,(IY+$03)
#DEFINE GLABELS_ON		set 6,(IY+$04)
#DEFINE GLABELS_OFF		res 6,(IY+$04)
#DEFINE GAXES_OFF		set 5,(IY+$04)
#DEFINE GAXES_ON		res 5,(IY+$04)
#DEFINE GCURSOR_OFF		set 4,(IY+$04)
#DEFINE GCURSOR_ON		res 4,(IY+$04)
#DEFINE GPOLAR_GC		set 3,(IY+$04)
#DEFINE GRECT_GC		res 3,(IY+$04)
#DEFINE GGRID_ON		set 2,(IY+$04)
#DEFINE GGRID_OFF		res 2,(IY+$04)
#DEFINE GSIMUL_G		set 1,(IY+$04)
#DEFINE GSEQ_G			res 1,(IY+$04)
#DEFINE GDRAW_DOT		set 0,(IY+$04)
#DEFINE GDRAW_LINE		res 0,(IY+$04)

;Ŀ
; Cursor Macros                                                             
;
#DEFINE CURSOR_ON		set 2,(IY+$0C)
#DEFINE CURSOR_OFF		res 2,(IY+$0C)
#DEFINE ALPHA_ON		set 4,(IY+$12)
#DEFINE ALPHA_OFF		res 4,(IY+$12)
#DEFINE USE_ALPHA		res 5,(IY+$12)
#DEFINE USE_alpha		set 5,(IY+$12)
#DEFINE LOCK_ALPHA		set 6,(IY+$12)
#DEFINE ULOCK_ALPHA		res 6,(IY+$12)
#DEFINE INSERT_ON		set 6,(IY+$05)
#DEFINE INSERT_OFF		set 6,(IY+$05)

;Ŀ
; Printing option macros                                                    
;
#DEFINE	PB_ON_W			res 3,(IY+$05)
#DEFINE PW_ON_B			set 3,(IY+$05)
#DEFINE PM7_ROWS		set 1,(IY+$05)
#DEFINE PM6_ROWS		res 1,(IY+$05)
#DEFINE PSCROLL			set 2,(IY+$0D)
#DEFINE PNO_SCROLL		res 2,(IY+$0D)
#DEFINE PAFFECT_TEXT		set 1,(IY+$0D)
#DEFINE PNO_AFFECT_TEXT		res 1,(IY+$0D)

;Ŀ
; Useful Misc. Command Macros                                               
;
#DEFINE APD_ON                  set 3,(IY+8) ; Turns APD on!  Wow!
#DEFINE APD_OFF                 res 3,(IY+8) ; Turns APD off!  Wow!
#DEFINE BBUSY_ON                set 0,(IY+$12)  ;turns busy indicator on
#DEFINE BBUSY_OFF               res 0,(IY+$12)  ;turns busy indicator off
#DEFINE GET_VAR                 LD_OP1_HL \ SEARCH_VAT

;Ŀ
; rst Commands                                                              
;
#DEFINE LD_OP2_OP1              rst 08H ; 11 bytes copied from OP1 to OP2
#DEFINE SEARCH_VAT              rst 10H ; Searches VAT for Variable
#DEFINE LD_OP1_HL               rst 20H ; OP1=(HL)
#DEFINE MUL_OP1_OP2             rst 28H ; OP1=OP1*OP2 (FP)
#DEFINE ADD_OP1_OP2             rst 30H ; OP1=OP1+OP2 (FP)

;Ŀ
; TI-85 Data Areas                                                          
;
APD_COUNTER	=$8008	; 2 byte counter used for APD
BLINK_COUNTER	=$800A	; 2 byte counter used for blinking cursors
DELCHAR_LEN	=$800F	; length of DELCHAR buffer (max 100)
DELCHAR_BUF	=$8010	; 100 byte buffer for copy/paste in program editor
TOPR_BITMAP     =$8078  ; bitmap of top right corner of display (8 bytes)
OP1		=$8082	; OP1 register for variable manipulation (11 bytes)
OP2		=$808D	; OP2 register for variable manipulation (11 bytes)
OP3		=$8098	; OP3 register for variable manipulation (11 bytes)
OP4		=$80A3	; OP4 register for variable manipulation (11 bytes)
                        ; Also used to store a ZT string of last thing
                        ; displayed on Home Screen
OP5		=$80AE	; OP5 register for variable manipulation (11 bytes)
OP6		=$80B9	; OP6 register for variable manipulation (11 bytes)
ANS_POINT       =$80D0  ; pointer to Ans
FINAL_VAT       =$80D6  ; pointer to last VAT entry
ERR_BUFFER      =$81AC  ; circular buffer used by error handler
C_FULL_SCR_VAR	=$81D0	; last var pointed at from full screen menu in format
			; of OP1
CURRENT_MENU	=$820E	; current menu pointers (10 bytes)
RAISED_MENU	=$8218	; current raised up menu (10 bytes)
LST_VAR_MENU    =$8222  ; last variable menu shown (50 bytes, 10 for each
                        ; entry)
USER_MENU	=$8254	; string area used for TI-BASIC menus (40 bytes)
TEMP_STORAGE    =$827C  ; 128 bytes
SCROLL_START	=$8B2F	; first row of scrolling for SCROLL_UP
SCROLL_END      =$8B30  ; last row of scrolling for SCROLL_UP
CUSTOM_MENU     =$8BB1  ; custom menu data
HIGH_STACK      =$FA70  ; Stack space

;Ŀ
; More TI-85 Data Areas                                                     
;
KEY_0		=$8000	; translated scancode of last key, but 0 if gotten
KEY_1		=$8001	; translated scancode of key down now
KEY_2		=$8002	; same as 8001, but $FF if more than one key is down
KEY_STAT	=$8004	; bit 2 set = key down now
LAST_KEY	=$8006	; last key pressed
CONTRAST	=$8007	; contrast
CURSOR_ROW	=$800C	; text cursor row
CURSOR_COL	=$800D	; text cursor column
CURSOR_LET      =$800E  ; letter under text cursor
BUSY_COUNTER	=$8080	; counter for busy indicator
BUSY_BITMAP	=$8081	; bitmap for busy indicator
CURR_INPUT	=$80C6	; -> current home-screen input
BYTES_USED	=$80CC	; # of used user memory (Add to 80C8 to find first 
			; byte of free memory)
TEXT_MEM	=$80DF	; text memory
CURSOR_ROW2     =$8187  ; text cursor row
CURSOR_COL2     =$8188  ; text cursor column
CHECKSUM	=$81BE	; memory checksum from 8BF7 to FA6F
CURSOR_X	=$8333	; x value of cursor
CURSOR_Y	=$8334	; y value of cursor
_IY_TABLE	=$8346	; where IY usually points
GRAPH_MEM	=$8641	; graphics memory
TEXT_MEM2	=$8A6B	; secondary text memory
USER_MEM	=$8B1B	; -> start of user memory
FIXED_POINT	=$8B3A	; fixed-point decimal place (FFh for floating point)
VAT_END		=$8BEB	; -> one byte before end of VAT (backwards)
VAT_START	=$FA6F	; start of VAT
VIDEO_MEM	=$FC00	; video memory

;Ŀ
; #DEFINEs for ZShell program conversion                                    
;
#DEFINE ROM_CALL(addr)          call addr
#DEFINE CALL_Z(addr)            call Z,addr
#DEFINE CALL_(addr)             call addr
#DEFINE CALL_NZ(addr)           call NZ,addr
#DEFINE CALL_C(addr)            call C,addr
#DEFINE CALL_NC(addr)           call NC,addr
#DEFINE JUMP_Z(addr)            jp Z,addr
#DEFINE JUMP_(addr)             jp addr
#DEFINE JUMP_NZ(addr)           jp NZ,addr
#DEFINE JUMP_C(addr)            jp C,addr
#DEFINE JUMP_NC(addr)           jp NC,addr

;Ŀ
; ZShell Specific Data areas                                                
;
PROGRAM_ADDR	=$8C3C	; program address
ROM_VERS	=$8C3E	; ROM version byte
ZSHELL_VER	=$8C3F	; ZShell version number
ZS_BITS		=$8C40	; bit 0 set : checksum again
                        ; bit 1 set : get out without screen

;Ŀ
; Call addresses                                                            
; These addresses are in the same location in all ROM versions, and can     
; therefor be accessed through a direct call.                               
; There is no need to use the ROM_CALL function.                            
; Instead, use e.g. "call LD_HL_MHL", without using any macro.              
;
LD_HL_MHL       =$0033  ; HL=(HL), A=L
CP_HL_DE        =$008E  ; CP HL,DE (modifies flags only)
UNPACK_HL       =$009A  ; unpacks one digit of HL into %A
D_COLON         =$0094  ; displays a ":" at normal text cursor
ETR_CHARPUT     =$0096  ; same as TR_CHARPUT ROM_CALL, but faster and in the
			; same place in ALL ROM versions
UPDATE_BUSY	=$00AC	; update busy counter & redraw bitmap
APD_RESET       =$0115  ; resets $8009 to $A1
READ_KEY        =$0168  ; get keystroke into %A, use ports directly
READ_KEYPAD     =$01A2  ; read keypad port directly
STORE_KEY       =$01B1  ; store immediate keystroke from %A
GET_KEY         =$01BE  ; get immediate keystroke into %A
ALPHA1          =$01CB  ; call ALPHA3 if alpha mode locked
ALPHA2          =$01D6
ALPHA3          =$01DA
ERR_WRITE	=$03D9	; write A% in to Error Buffer
GET_CHECKSUM    =$0CAD  ; check sum memory between 8BF7 and FA6F

;Ŀ
; Jump addresses                                                            
;
HOME_SCREEN	=$0462	; jump to home screen, and display contents of
			; TEXT_MEM as ascii equivalents
D_ERROR         =$0A87  ; display Error number A%

;Ŀ
; Call Addresses                                                            
; Just use them like the ones above                                         
;
ROM_TABLE       =$8C41        ; DO NOT MODIFY THIS LINE
TX_CHARPUT       =ROM_TABLE   ; xlated display of %A on screen, normal text style
D_LT_STR         =ROM_TABLE+3 ; display length-byte normal text string
M_CHARPUT        =ROM_TABLE+6 ; display %A on screen, menu style
D_ZM_STR         =ROM_TABLE+9 ; display zero-terminated string,  menu style
D_LM_STR         =ROM_TABLE+12; display length-byte string, menu style
GET_T_CUR        =ROM_TABLE+15; HL = absolute address of text cursor
SCROLL_UP        =ROM_TABLE+18; scroll text screen up
TR_CHARPUT       =ROM_TABLE+21; raw display of %A on screen, normal text style
CLEARLCD         =ROM_TABLE+24; clear LCD, but not text or graphics memory
D_HL_DECI        =ROM_TABLE+27; disp. HL as 5-byte, right just., blank-pad. decimal
CLEARTEXT        =ROM_TABLE+30; clear LCD and text memory (affected by 1,(IY+13))
D_ZT_STR         =ROM_TABLE+33; display zero-terminated normal text string
BUSY_OFF         =ROM_TABLE+36; turn off "busy" indicataor
BUSY_ON          =ROM_TABLE+39; turn on "busy" indicator
FIND_PIXEL       =ROM_TABLE+42; Find location in RAM for a pixel on the GFX screen
                        ; WARNING! Page must be set to 4 before this function
                        ; is called! Do "ld a,4" and "out (5),a" do to that.

;Ŀ
; Peak Specific Internal Routines                                           
;
EXE             =$8C05  ;Execute varible name in OP1
PATCH           =$8E14  ;Patch ROM data from HL to DE
FILL8           =$8E17  ;Fill B bytes at HL with %A
CHECK_VAT       =$8E1A  ;Search VAT for var type %A

;Ŀ
; Peak Specific Data areas                                                  
;
VC_NAME         =$8E1D  ;Return area for VAT_CHECK
ORIGIN          =$906D  ;Start area for relocation programs (.org)

;Ŀ
; Key Scan Codes        Function                Character                   
;
;                                        
K_NOKEY         = $00    ;No key
K_DOWN          = $01    ;Down
K_LEFT          = $02    ;Left
K_RIGHT         = $03    ;Right
K_UP            = $04    ;Up
K_ENTER         = $09    ;Enter
K_PLUS          = $0A    ;+                      X
K_MINUS         = $0B    ;-                      T
K_STAR          = $0C    ;*                      O
K_SLASH         = $0D    ;/                      J
K_RAISE         = $0E    ;^                      E
K_CLEAR         = $0F    ;Clear
K_SIGN          = $11    ;(-)                    Space
K_3             = $12    ;3                      W
K_6             = $13    ;6                      S
K_9             = $14    ;9                      N
K_RIGHTPAR      = $15    ;)                      I
K_TAN           = $16    ;Tan                    D
K_CUSTOM        = $17    ;Custom
K_DOT           = $19    ;.                      Z
K_2             = $1A    ;2                      V
K_5             = $1B    ;5                      R
K_8             = $1C    ;8                      M
K_LEFTPAR       = $1D    ;(                      H
K_COS           = $1E    ;Cos                    C
K_PRGM          = $1F    ;Prgm
K_DEL           = $20    ;Del
K_0             = $21    ;0                      Y
K_1             = $22    ;1                      U
K_4             = $23    ;4                      Q
K_7             = $24    ;7                      L
K_EE            = $25    ;EE                     G
K_SIN           = $26    ;Sin                    B
K_STAT          = $27    ;Stat
K_XVAR          = $28    ;x-Var                  x
K_ON            = $29    ;On
K_STO           = $2A    ;Sto                    =
K_COMMA         = $2B    ;,                      P
K_SQUARE        = $2C    ;x^2                    K
K_LN            = $2D    ;Ln                     F
K_LOG           = $2E    ;Log                    A
K_GRAPH         = $2F    ;Graph
K_ALPHA         = $30    ;Alpha
K_F5            = $31    ;F5
K_F4            = $32    ;F4
K_F3            = $33    ;F3
K_F2            = $34    ;F2
K_F1            = $35    ;F1
K_SECOND        = $36    ;2nd
K_EXIT          = $37    ;EXIT
K_MORE          = $38    ;MORE


